/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.lokalisierung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.lokalisierung.boundary.AbstractLokalisierungSearchParameters;
import de.ivu.elect.business.lokalisierung.boundary.LokalisierungChangeEvent;
import de.ivu.elect.business.lokalisierung.boundary.LokalisierungConversationStore;
import de.ivu.elect.business.lokalisierung.boundary.LokalisierungExtendedDAO;
import de.ivu.elect.business.lokalisierung.boundary.LokalisierungSearch;
import de.ivu.elect.business.lokalisierung.boundary.LokalisierungSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.lokalisierung.entity.Lokalisierung;
import de.ivu.elect.business.lokalisierung.entity.LokalisierungMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractLokalisierungSearchView.COMPONENT_NAME)
@View(viewId = AbstractLokalisierungSearchView.VIEW_ID, useCase = UseCasePermission.LOKALISIERUNG_SEARCH)
public abstract class AbstractLokalisierungSearchView extends AbstractElectSearchView<Lokalisierung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "lokalisierungSearchView";
  
  public static final String VIEW_ID = "/lokalisierung/lokalisierung-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractLokalisierungSearchView requestHandler;

  @Inject
  private transient LokalisierungExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(LokalisierungConversationStore.class)
  protected transient LokalisierungConversationStore conversationStore;

  @Inject
  protected transient LokalisierungSearch search;

  @Inject
  @ConversationGroup(AbstractLokalisierungSearchParameters.class)
  protected transient LokalisierungSearchParameters searchParameters;

  @Inject
  protected transient LokalisierungMeta entityMeta;

  public AbstractLokalisierungSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Lokalisierung getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Lokalisierung entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public LokalisierungSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Lokalisierung> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Lokalisierung> create();
  }

  @Override
  public List<Lokalisierung> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Lokalisierung> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onLokalisierungChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) LokalisierungChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractLokalisierungSearchView {

    @View
    @Inject
    private transient Instance<AbstractLokalisierungSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractLokalisierungSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
